<template>
    <div>
        <div class="breadcrumbs">
            <router-link to="/main">{{$t('message.main')}}</router-link>
            <div class="circle"></div>
            <div>{{$t('message.create_package')}}</div>
        </div>

        <form @submit.prevent="" v-if='!package_created' class="form create_order">
            <div v-if="active_tab == 'tab-3' || active_tab == 'tab-2'" class="block order_info">
                <div class="data_block width_limiter desktop">
                    <div class="data">
                        <div class="from">
                            <div class="cell">
                                {{$t('message.from')}}
                            </div>
                            <div class="cell">
                                <div class="item" style="text-transform: capitalize;">
                                    {{from_full_name}}
                                </div>
                                <div class="item">
                                    {{ getFormatedPhone(from_phone) }}
                                </div>
                                <div class="item">
                                    {{$t('message.short_city_prefix')}}
                                    {{from_city.name_ua ? from_city.name_ua : from_city.city.name_ua}},
                                    {{$t('message.department')}}
                                    {{from_department_no}}
                                </div>
                            </div>
                        </div>
                        <div class="line"></div>
                        <div class="to">
                            <div class="cell">
                                {{$t('message.to')}}
                            </div>
                            <div class="cell">
                                <div class="item" style="text-transform: capitalize;">
                                    {{to_full_name}}
                                </div>
                                <div class="item">
                                    {{ getFormatedPhone(to_phone) }}
                                </div>
                                <div class="item">
                                    {{$t('message.short_city_prefix')}}
                                    {{to_city.name_ua ? to_city.name_ua : to_city.city.name_ua}},
                                    {{$t('message.department')}}
                                    {{to_department_no}}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="v-tabs__div action">
                        <a href="#tab-1" class="v-tabs__item" onclick="document.querySelector('#tabClick a').click()">
                            {{$t('message.change')}}
                        </a>
                    </div>
<!--                    <v-tab class="action" href="#tab-1" :ripple="false" >-->
<!--                        -->
<!--                    </v-tab>-->
                </div>
                <div v-if="active_tab == 'tab-3'" class="data_block width_limiter fix-margin desktop">
                    <div :class="{data: true, checked: check_info}">
                        <div class="from">
                            <div class="cell">
                                {{$t('message.cargo')}}:
                            </div>
                            <div class="cell">
                                <div class="item">
                                    {{count_cargo_places_label}}
                                </div>
                                <div class="item">
                                    {{$t('message.max_size')}}
                                    -
                                    {{max_size}}
                                    {{$t('message.sm')}}
                                </div>
                                <div class="item">
                                    {{$t('message.weight')}}
                                    -
                                    {{weight}}
                                    {{$t('message.kg')}}
                                </div>
                                <div class="item">
                                    {{$t('message.standard_size')}}
                                    -
                                    {{box_size}}
                                </div>
                                <div class="item">
                                    {{$t('message.declared_cost')}}
                                    -
                                    {{declared_cost}}
                                    {{$t('message.short_money_prefix')}}
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="v-tabs__div action">
                        <a href="#tab-2" class="v-tabs__item" onclick="document.querySelector('#tabClick2 a').click();">
                            {{$t('message.change')}}
                        </a>
                    </div>
                </div>
            </div>
            <v-tabs @change="scrollTop" ref="tabs" v-model="tab">
                <v-tabs-slider></v-tabs-slider>
                <v-tab href="#tab-1" :ripple="false" id="tabClick">
                    {{$t('message.create_package')}}
                </v-tab>
                <v-tab :disabled="!second_is_avaliable" href="#tab-2" id="tabClick2" :ripple="false">
                    {{$t('message.cargo_info')}}
                </v-tab>

                <v-tab-item :key="1" :value="'tab-1'">
                    <v-card flat>
                        <v-card-text>
                            <div class="block" style="padding-bottom: 0">
                                <div class="block-title">
                                    {{$t('message.from')}}
                                </div>

                                <div class="row">
                                    <div class="full_width">
                                        <div class="input_component">
                                            <v-text-field
                                                v-model='user.last_name'
                                                id='from_surname'
                                                name='from_surname'
                                                @keypress='handleCyrilic'
                                                @input.native="handleInput(['user','last_name'])"
                                                :placeholder="$t('message.second_name')"
                                                :class="{'error':(!user.last_name && validate_first_tab), parent_active_focus: user.last_name}"
                                            >
                                                <template slot="label">{{ $t('message.second_name') }}</template>
                                            </v-text-field>
                                            <span class="label">{{ $t('message.required') }}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <v-text-field
                                                v-model='user.first_name'
                                                id='from_name'
                                                name='from_name'
                                                @keypress='handleCyrilic'
                                                @input.native="handleInput(['user','first_name'])"
                                                :placeholder="$t('message.first_name')"
                                                :class="{'error':(!user.first_name && validate_first_tab), parent_active_focus: user.first_name}"
                                            >
                                                <template slot="label">{{$t('message.first_name')}}</template>
                                            </v-text-field>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <v-text-field
                                                v-model='user.middle_name'
                                                id='from_middle_name'
                                                name="from_middle_name"
                                                @keypress='handleCyrilic'
                                                @input.native="handleInput(['user','middle_name'])"
                                                :placeholder="$t('message.last_name')"
                                                :class="{'error':(!user.middle_name && validate_first_tab), parent_active_focus: user.middle_name}"
                                            >
                                                <template slot="label">{{$t('message.last_name')}}</template>
                                            </v-text-field>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="full_width">
                                        <div class="input_component phone">
                                            <the-mask
                                                v-model='user.phone'
                                                type="text"
                                                placeholder="+38 (0##) ###-##-##"
                                                @focus.native="handleFocus"
                                                :mask="['+38 (0##) ###-##-##']"
                                                :masked="true"
                                                :class="{'error':(!is_from_phone_valid && validate_first_tab), active_focus: is_from_phone_valid}"
                                            ></the-mask>
                                            <div class="lbl">{{$t('message.phone')}}</div>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <cities-input
                                                v-model="from_city_name"
                                                @refresh="refreshCity('from')"
                                                @set-city="setCity($event, 'from')"
                                                class="order"
                                                :placeholder="$t('message.from')"
                                                :cities="cities"
                                                :class="{'error':(((!from_city_name.length && validate_first_tab) || (!Object.keys(from_city).length && validate_first_tab) ) && (!from_city_name || !Object.keys(from_city).length)), parent_active_focus: from_city_name}"
                                            ></cities-input>
                                            <span class="label">{{from_city_error}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <department-input
                                                v-model="from_department_no"
                                                @set-department="setDepartment($event, 'from')"
                                                @refresh="setDepartment({}, 'from')"
                                                @set-city="setCityByDepartment($event, 'from')"
                                                :departments="from_departments"
                                                :placeholder="$t('message.department_no')"
                                                :class="{'error':((!from_department_no.length && validate_first_tab) || (!Object.keys(from_department).length && validate_first_tab) ) , parent_active_focus: from_department_no}"
                                            ></department-input>
                                            <span class="label">{{from_department_error}}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="block color" style="padding-bottom: 0">
                                <div class="block-title">
                                    {{$t('message.to')}}
                                </div>
                                <div class="row">
                                    <div class="full_width">
                                        <div class="input_component">
                                            <v-text-field
                                                id='to_surname'
                                                name='to_surname'
                                                v-model='to_surname'
                                                v-bind:placeholder="$t('message.second_name')"
                                                @keypress='handleCyrilic'
                                                @input.native="handleInput('to_surname')"
                                                :class="{'error':(!to_surname.length && validate_first_tab), parent_active_focus: to_surname}"
                                            >
                                                <template slot="label">{{$t('message.second_name')}}</template>
                                            </v-text-field>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <v-text-field
                                                id='to_name'
                                                name='to_name'
                                                v-model='to_name'
                                                @keypress='handleCyrilic'
                                                @input.native="handleInput('to_name')"
                                                :placeholder="$t('message.first_name')"
                                                :class="{'error':(!to_name.length && validate_first_tab), parent_active_focus: to_name}"
                                            >
                                                <template slot="label">{{$t('message.first_name')}}</template>
                                            </v-text-field>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <v-text-field
                                                id='to_middle_name'
                                                name='to_middle_name'
                                                v-model="to_middle_name"
                                                @keypress='handleCyrilic'
                                                @input.native="handleInput('to_middle_name')"
                                                :placeholder="$t('message.last_name')"
                                                :class="{'error':(!to_middle_name.length && validate_first_tab), parent_active_focus: to_middle_name}"
                                            >
                                                <template slot="label">{{$t('message.last_name')}}</template>
                                            </v-text-field>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="full_width">
                                        <div class="input_component phone">
                                            <the-mask
                                                v-model='to_phone'
                                                type="text"
                                                placeholder="+38 (0##) ###-##-##"
                                                @focus.native = handleFocus
                                                :mask="['+38 (0##) ###-##-##']"
                                                :masked="true"
                                                :class="{'error':(!is_to_phone_valid && validate_first_tab), active_focus: is_to_phone_valid}"
                                            ></the-mask>
                                            <div class="lbl">{{$t('message.phone')}}</div>
                                            <span class="label">{{$t('message.required')}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <cities-input
                                                v-model="to_city_name"
                                                :placeholder="$t('message.to')"
                                                :cities='cities'
                                                @refresh="refreshCity('to')"
                                                @set-city="setCity($event, 'to')"
                                                class="order"
                                                :class="{'error':(((!to_city_name.length && validate_first_tab) || (!Object.keys(to_city).length && validate_first_tab) ) && (!to_city_name || !Object.keys(to_city).length)), parent_active_focus: to_city_name}"
                                            ></cities-input>
                                            <span class="label">{{to_city_error}}</span>
                                        </div>
                                    </div>
                                    <div class="full_width">
                                        <div class="input_component">
                                            <department-input
                                                v-model="to_department_no"
                                                @set-department="setDepartment($event, 'to')"
                                                @refresh="setDepartment({}, 'to')"
                                                @set-city="setCityByDepartment($event, 'to')"
                                                :departments="to_departments"
                                                :placeholder="$t('message.department_no')"
                                                :class="{'error':((!to_department_no.length && validate_first_tab) || (!Object.keys(to_department).length && validate_first_tab) ), parent_active_focus: to_department_no}"
                                            ></department-input>
                                            <span class="label">{{to_department_error}}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="block color buttons last align_right">
                                <div class="row">
                                    <v-tab class="button" :href="second_is_avaliable ? '#tab-2' : ''" :ripple="false" @click="validateFirstTab">
                                        {{$t('message.next_step')}}
                                    </v-tab>
                                </div>
                            </div>
                        </v-card-text>
                    </v-card>
                </v-tab-item>

                <v-tab-item :key="2" :value="'tab-2'">
                    <v-card flat>
                        <v-card-text>
                            <div v-if="active_tab == 'tab-3' || active_tab == 'tab-2'" class="block order_info mobile">
                                <div class="data_block width_limiter">
                                    <div :class="{data: true, checked: check_info}">
                                        <div class="from">
                                            <div class="item">
                                                {{$t('message.from')}}:
                                            </div>
                                            <div class="item" style="text-transform: capitalize;">
                                                {{from_full_name}},
                                            </div>
                                            <div class="item">
                                                {{ getFormatedPhone(from_phone) }},
                                            </div>
                                            <div class="item">
                                                {{$t('message.short_city_prefix')}}
                                                {{from_city.name_ua ? from_city.name_ua : from_city.city.name_ua}},
                                                {{$t('message.department')}}
                                                {{from_department_no}}
                                            </div>
                                        </div>

                                        <div class="to">
                                            <div class="item">
                                                {{$t('message.to')}}:
                                            </div>
                                            <div class="item" style="text-transform: capitalize;">
                                                {{to_full_name}},
                                            </div>
                                            <div class="item">
                                                {{ getFormatedPhone(to_phone) }},
                                            </div>
                                            <div class="item">
                                                {{$t('message.short_city_prefix')}}
                                                {{to_city.name_ua ? to_city.name_ua : to_city.city.name_ua}},
                                                {{$t('message.department')}}
                                                {{to_department_no}}
                                            </div>
                                        </div>
                                    </div>

                                    <div :class="{'v-tabs__div': true, action: true, checked: check_info}">
                                        <a href="#tab-1" class="v-tabs__item" onclick="document.querySelector('#tabClick a').click()">
                                            {{$t('message.change')}}
                                        </a>
                                    </div>

                                    <div :class="{check_info_btn: true, checked: check_info}" @click="check_info = true">{{$t('message.check_info')}}</div>
                                    <div :class="{violet_hover: true, checked: check_info}"></div>
                                </div>
                            </div>

                            <div class="block package_data">
                                <div class="places">
                                    <div class="row">
                                        <div class="col-title center">
                                            {{$t('message.cargo_count')}}
                                        </div>
                                    </div>

                                    <div class="place_moule">
                                        <button type='button' @click='count_cargo_places--'>
                                            <img :src="(package_count == 1) ? '/img/c-minus-disable.svg' : '/img/c-minus.svg'">
                                        </button>
                                        <div class="count">
                                            {{count_cargo_places}}
                                        </div>
                                        <button type='button' @click='count_cargo_places++'>
                                            <img :src="(package_count == 10) ? '/img/c-plus-disable.svg' : '/img/c-plus.svg'">
                                        </button>
                                    </div>
                                </div>

                                <div class="information">
                                    <div class="col-title">
                                        {{$t('message.general_cargo_info')}}
                                    </div>

                                    <div class="row sizes_inputs">
                                        <div class="f-input">
                                            <div class="input_component">
                                                <vue-mask
                                                    v-model="weight"
                                                    mask="0Z.Z"
                                                    :raw="false"
                                                    :options="{placeholder:$t('message.weight'),translation:translation}"
                                                    :class="{parent_active_focus: weight, error: (!is_weight_valid || (validate_second_tab && !weight))}"
                                                    class="vue-mask"
                                                >
                                                </vue-mask>
                                                <div class="lbl">{{$t('message.weight')}}</div>
                                                <div class="tltp">{{$t('message.weight_tooltip')}}</div>

                                                <div class="measurement">{{$t('message.kg')}}</div>
                                                <span v-if="!weight" class="label">{{$t('message.required')}}</span>
                                                <span v-if="weight_error" class="label">{{weight_error}}</span>
                                            </div>
                                        </div>

                                        <div class="f-input">
                                            <div class="input_component">
                                                <vue-mask
                                                    v-model="max_size"
                                                    mask="0Z"
                                                    :options="{placeholder:$t('message.max_size_shrt'),translation:translation}"
                                                    :class="{parent_active_focus: max_size, error: (!is_max_size_valid || (validate_second_tab && !max_size))}"
                                                    class="vue-mask"
                                                >
                                                </vue-mask>
                                                <div class="lbl">{{$t('message.max_size_shrt')}}</div>
                                                <div class="tltp">{{$t('message.max_size_tooltip')}}</div>
                                                <div class="measurement">{{$t('message.sm')}} </div>
                                                <span v-if="!max_size" class="label">{{$t('message.required')}}</span>
                                                <span v-if="length_error" class="label">{{length_error}}</span>
                                            </div>
                                        </div>

                                        <div class="f-input">
                                            <div class="input_component">
                                                <vue-mask
                                                    v-model="declared_cost"
                                                    mask="0ZZZZZ"
                                                    :options="{placeholder:$t('message.declared_cost'),translation:translation}"
                                                    :class="{error: ((!declared_cost && validate_second_tab) || !is_cost_valid), parent_active_focus: declared_cost}"
                                                    class="vue-mask"
                                                >
                                                </vue-mask>
                                                <div class="lbl">{{$t('message.declared_cost')}}</div>
                                                <div class="tltp">{{$t('message.cost_tooltip')}}</div>
                                                <div class="measurement">{{$t('message.short_money_prefix')}}</div>
                                                <span v-if="!declared_cost" class="label">{{$t('message.required')}}</span>
                                                <span v-if="declared_cost_error" class="label">{{declared_cost_error}}</span>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="row last">
                                        <div class="full_width">
                                            <div class="input_component fix-margin">
                                                <input v-model='description'
                                                       class="input_100"
                                                       @blur="handleDesc"
                                                       :placeholder="$t('message.description')"
                                                       :class="{'error':((!description.length && validate_second_tab) || (!is_desc_valid && validate_second_tab) || this.desc_error), parent_active_focus: description}">
                                                <div class="lbl">{{ $t('message.description') }}</div>
                                                <div class="tltp">{{ $t('message.description_tooltip') }}</div>
                                                <span v-if="!description" class="label">{{$t('message.required')}}</span>
                                                <span v-if="desc_error" class="label">{{desc_error}}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="block color" style="padding-bottom: 0">
                                <div class="package_total_data width_limiter">
                                    <div class="row">
                                        <div class="package_total_value">
                                            <div class="col-title">
                                                {{$t('message.declared_cost')}}
                                            </div>
                                            <div class="value">
                                                {{declared_cost || 0}}
                                                {{$t('message.short_money_prefix')}}
                                            </div>
                                        </div>

                                        <div :class="{payback: true, active: payback_select == true}" @click="paybackSelelectTrigger">
                                            <div :class="{switcher: true, active: payback_select == true}"></div>
                                            <div class="payback_container">
                                                <div class="payback_container_label">
                                                    {{$t('message.get_payback')}}
                                                </div>
                                                <div :class="{payback: true, active: payback_select == true}" @click="paybackSelelectTrigger">
                                                    <input id='get_payback' type="checkbox" style="display: none">
                                                </div>
                                            </div>
                                        </div>
                                     </div>
                                 </div>
                            </div>

                            <div class="back_payment" v-if="payback_select">
                                <div class="block payback_block">
                                    <div class="box_title">{{$t('message.payback_title')}}</div>

                                    <div class="row payemnt_data">
                                        <div class="total_price">
                                            <div class="col-title">
                                                {{$t('message.payback_cost')}}
                                            </div>
                                            <div class="input">
                                                <input type="text" placeholder="" v-model="declared_cost" readonly>
                                                <div class="measurement">
                                                    {{$t('message.short_money_prefix')}}
                                                </div>
                                            </div>
                                        </div>

                                        <div class="recive_payment" id="recive_payment">
                                            <div class="col-title">
                                                {{$t('message.getting_funds')}}
                                            </div>
                                            <div class="input_data">
                                                <v-radio-group v-model="pay_way" col>
                                                    <v-radio :ripple="false" :label="$t('message.cash')" value="cash"></v-radio>
                                                    <v-radio :ripple="false" :label="$t('message.card')" value="card"></v-radio>
                                                </v-radio-group>
                                                <div class="credit_card_input">
                                                    <the-mask
                                                        :mask="['#### #### #### ####']"
                                                        type="text"
                                                        placeholder="xxxx xxxx xxxx xxxx"
                                                        id='card_number'
                                                        name="card_number"
                                                        :label="$t('message.card_number')"
                                                        v-model='card_number'
                                                        hint="At least 2 characters"
                                                        v-if='pay_way == "card"'
                                                        :class="{credit_card_input: true, active_focus: is_card_valid, error: (!is_card_valid && card_number)}"
                                                    ></the-mask>
                                                    <span v-if="(!is_card_valid && card_number)" class="label">{{$t('message.invalid_cod')}}</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="block color" style="padding-bottom: 0">
                                    <div class="row calculate">
                                        <div class="delivery_amount">
                                            <div class="data">
                                                <button @click="calculate" :disabled="isDisabledCalculateBtn" type="button" class="button">
                                                    {{$t('message.calculate')}}
                                                </button>

                                                <div class="amount">
                                                    <div class="col-title">
                                                        {{$t('message.delivery_amount')}}
                                                    </div>
                                                    <div class="value">
                                                        {{delivery_amount}}
                                                        {{delivery_amount ? $t('message.short_money_prefix'): ''}}
                                                    </div>
                                                </div>

                                                <div class="box">
                                                    <div class="col-title">
                                                        {{$t('message.box_size')}}
                                                    </div>
                                                    <div class="value">
                                                        {{this.box_size}}
                                                    </div>
                                                </div>

                                                <div class="payer">
                                                    <div class="col-title">
                                                        {{$t('message.payer')}}
                                                    </div>
                                                    <v-radio-group v-model="payer">
                                                        <v-radio :label="$t('message.sender')" value="sender" :ripple="false"></v-radio>
                                                        <v-radio :label="$t('message.receiver')" value="receiver" :ripple="false"></v-radio>
                                                    </v-radio-group>
                                                </div>
                                                <div v-if="isLoading" class="animation-container">
                                                    <lottie :options="defaultOptions" :height="150" :width="150"/>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="row total_data_wrap">
                                        <div class="total_data">
                                            <div class="data">
                                                <div class="total_amount">
                                                    <div class="col-title">
                                                        {{$t('message.total_cost')}}
                                                    </div>
                                                    <div class="value">
                                                        {{parseInt(declared_cost || 0) + parseInt(delivery_amount) + transfer_cost}}
                                                        {{$t('message.short_money_prefix')}}
                                                    </div>
                                                </div>
                                                <div class="items_amount">
                                                    <div class="item">
                                                        <div class="col-title">
                                                            {{$t('message.delivery')}}:
                                                        </div>
                                                        <div class="value">
                                                            {{delivery_amount}}
                                                            {{$t('message.short_money_prefix')}}
                                                        </div>
                                                    </div>
                                                    <div class="line"></div>
                                                    <div class="item">
                                                        <div class="col-title">
                                                            {{$t('message.payback')}}:
                                                        </div>
                                                        <div class="value">
                                                            {{declared_cost}}
                                                            {{$t('message.short_money_prefix')}}
                                                        </div>
                                                    </div>
                                                    <div class="item">
                                                        <div class="col-title">
                                                            {{$t('message.transfer_cost')}}:
                                                        </div>
                                                        <div class="value">
                                                            {{transfer_cost}}
                                                            {{$t('message.short_money_prefix')}}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <button :disabled="isDisabledSubmit" class="button" @click="createPackage">
                                                {{$t('message.create_parcel')}}
                                            </button>
                                        </div>

                                        <template v-if="show_annotation">
                                            <div class="annotation">
                                                <div>{{$t('message.approve_declared_cost')}}</div>
                                                <div>{{$t('message.approve_identity')}}</div>
                                            </div>
                                        </template>
                                    </div>
                                </div>
                            </div>

                            <div class="block color">
                                <div v-if="!get_payback" class="row calculate">
                                    <div class="delivery_amount">
                                        <div class="data">
                                            <button
                                                @click='calculate'
                                                :disabled="isDisabledCalculateBtn"
                                                type='button'
                                                class="button">
                                                {{$t('message.calculate')}}
                                            </button>

                                            <div class="amount">
                                                <div class="col-title">
                                                    {{$t('message.delivery_amount')}}
                                                </div>

                                                <div class="value">
                                                    {{delivery_amount}}
                                                    {{delivery_amount ? $t('message.short_money_prefix'): ''}}
                                                </div>
                                            </div>

                                            <div class="box">
                                                <div class="col-title">
                                                    {{$t('message.box_size')}}
                                                </div>
                                                <div class="value">
                                                    {{this.box_size}}
                                                </div>
                                            </div>

                                            <div class="payer">
                                                <div class="col-title">
                                                    {{$t('message.payer')}}
                                                </div>
                                                <v-radio-group v-model="payer">
                                                    <v-radio :label="$t('message.sender')" value="sender" :ripple="false"></v-radio>
                                                    <v-radio :label="$t('message.receiver')" value="receiver" :ripple="false"></v-radio>
                                                </v-radio-group>

                                            </div>
                                            <div v-if="isLoading" class="animation-container">
                                                <lottie :options="defaultOptions" :height="150" :width="150"/>
                                            </div>
                                        </div>

                                    </div>
                                </div>

                                <div v-if="!get_payback" class="row create_order_button_block">
                                    <template v-if="show_annotation">
                                        <div class="annotation">
                                            <div>{{$t('message.approve_declared_cost')}}</div>
                                            <div>{{$t('message.approve_identity')}}</div>
                                        </div>
                                    </template>

                                    <button :disabled="isDisabledSubmit" @click="createPackage" class="button">
                                        {{$t('message.create_parcel')}}
                                    </button>
                                </div>

                                <div class="row">
                                    <button class="back_arrow" onclick="document.getElementById('tabClick').getElementsByClassName('v-tabs__item')[0].click()">
                                        <div class="icon">
                                            <img src="/img/back_arrow_grey.svg">
                                        </div>
                                        <div>
                                            {{$t('message.back')}}
                                        </div>
                                    </button>
                                </div>
                            </div>
                        </v-card-text>
                    </v-card>
                </v-tab-item>
            </v-tabs>
        </form>
    </div>
</template>

<script>
    import CitiesInput from "./../DeliveryCalculator/CitiesInput";
    import DepartmentInput from "./../DeliveryCalculator/DepartmentInput";
    import vueMask from 'vue-jquery-mask';
    import Lottie from 'vue-lottie';
    import * as animationData from "../animation/preload";

    export default {
        components: {
            "cities-input": CitiesInput,
            "department-input": DepartmentInput,
            vueMask,
            'lottie': Lottie
        },
        data: () => ({
            tab: 'tab-1',
            to_surname: '',
            to_name: '',
            to_middle_name: '',
            to_phone: '',
            to_city: {},
            to_city_name: '',
            from_city: {},
            from_city_name: '',
            to_department_no: '',
            to_departments: {},
            to_department: {},
            from_department_no: '',
            from_departments: {},
            from_department: {},
            payer: 'sender',
            pay_way: 'cash',
            card_number: '',
            get_payback: false,
            description: '',
            max_size: '',
            weight: null,
            errors: {},
            delivery_amount: 0,
            must_calculate: true,
            declared_cost: '',
            package_count: 1,
            places_list: true,
            payback_select: false,
            payback_amount: '',
            box_size: '-',
            rules: {
                float: v => parseFloat(v) == v || 'float only',
            },
            places: [
                {
                    place_name: 'Oб`єкт 1',
                    max_size: '',
                    weight: ''
                },
            ],
            validate_first_tab: false,
            validate_second_tab: false,
            is_max_size_valid: true,
            is_weight_valid: true,
            is_desc_valid: true,
            is_cost_valid: true,
            active_tab: 0,
            show_annotation: false,
            check_info: false,
            in_progress: false,
            translation: {
                'Z': {
                    pattern: /[0-9]/,
                    optional: true
                }
            },
            defaultOptions: {animationData: animationData.default},
            animationSpeed: 1,
            isLoading: false
        }),
        methods: {
            handleFocus (e) {
                e.currentTarget.value = e.currentTarget.value ? e.currentTarget.value : '+38 (0';
            },
            handleMaxCostLength (e) {
                let allowed_key_code = [8,37,39,46,35];
                let max_length = 6;
                if(
                    (e.currentTarget.value.length >= max_length )
                    && !allowed_key_code.includes(e.keyCode)
                    && (e.currentTarget.selectionStart == e.currentTarget.selectionEnd)
                ) {
                    this.$store.dispatch('setDeclaredCostError', this.$t('message.max_length_declared_cost'));
                    this.is_cost_valid = false;
                    e.stopPropagation();
                    e.preventDefault();
                    return false;
                }
            },
            handleWeight (e) {
                let allowed_key_code = [8,37,39,46,35];
                let max_length = 3;
                if(
                    (e.currentTarget.value.length >= max_length )
                    && !allowed_key_code.includes(e.keyCode)
                    && (e.currentTarget.selectionStart == e.currentTarget.selectionEnd)
                ) {
                    this.$store.dispatch('setWeightError', this.$t('message.weight_limit_prefix') + this.to_department.weight_limit + this.$t('message.kg'));
                    this.is_weight_valid = false;
                    e.stopPropagation();
                    e.preventDefault();
                }
            },
            handleMaxSizeLength (e) {
                let allowed_key_code = [8,37,39,46,35];
                let max_length = 2;
                if(
                    (e.currentTarget.value.length >= max_length )
                    && !allowed_key_code.includes(e.keyCode)
                    && (e.currentTarget.selectionStart == e.currentTarget.selectionEnd)
                ) {
                    this.$store.dispatch('setLengthError', this.$t('message.length_limit'));
                    this.is_max_size_valid = false;
                    e.preventDefault();
                }
            },
            validateFirstTab() {
                this.validate_first_tab = true;
            },
            // расчет стоимости посылки
            async calculate() {
                this.validate_second_tab = true;
                this.isLoading = true;

                const calculateData = {
                    from: this.from_city.uuid,
                    to: this.to_city.uuid,
                    max_length: this.max_size,
                    weight: this.weight,
                    payer: this.payer
                };
                try{
                    const {data} = await axios.post('/order/calculate', calculateData);
                    // this.price = data.result.price;
                    this.box_size = data.result.size;
                    this.delivery_amount = parseInt(data.result.price);
                    this.must_calculate = false;
                } catch (e){
                    this.$store.commit('set_errors', {text: [e.response.data]});
                    this.$modal.show('error');
                }

                this.isLoading = false;
            },
            // создание посылки
            async createPackage() {
                this.validate_second_tab = true;

                this.in_progress = true;
                this.isLoading = true;
                const formData = this.preparePackageInfo();
                try{
                    const {data} = await axios.post('/order/create', formData);
                    this.$store.commit('setOrderStatus', data);
                } catch (e){
                    this.$store.commit('set_errors', {text: [e.response.data]});
                    this.$modal.show('error');
                }
                this.in_progress = false;
                this.isLoading = false;
            },
            preparePackageInfo(){
                const formData = {
                    sender_data: {
                        sender_phone: this.preparePhone(this.from_phone),
                        sender_surname: this.from_middle_name,
                        sender_first_name: this.from_name,
                        sender_last_name: this.from_surname,
                        sender_point_id: this.from_department.department_no + ''
                    },
                    receiver_data: {
                        receiver_phone: this.preparePhone(this.to_phone),
                        receiver_surname: this.to_middle_name,
                        receiver_first_name: this.to_name,
                        receiver_last_name: this.to_surname,
                        receiver_point_id: this.to_department.department_no + ''
                    },
                    shipment_data: {
                        cargo_places_quantity: parseInt(this.count_cargo_places),
                        max_width: parseInt(this.max_size),
                        weight: parseFloat(this.weight),
                        declared_cost: parseInt(this.declared_cost),
                        description: this.description
                    },
                    shipment_payment_details: {
                        delivery_payer: this.payer === 'sender' ? 0 : 1
                    }
                };
                // если обратный платеж
                if( this.get_payback ){
                    formData['shipment_payment_details']['cod_commission_payer'] = 1;
                    formData['shipment_payment_details']['cod'] = parseInt(this.declared_cost);
                    formData['shipment_payment_details']['cod_method'] = this.pay_way === 'cash' ? 0 : 1;
                    if( this.pay_way === 'card' ){
                        formData['shipment_payment_details']['card_code'] = this.card_number;
                    }
                }
                return formData;
            },
            preparePhone(phone){
                let cleanPhone = phone.replace(/[^\d\+]/g, '');
                const prependPart = '+380';
                if( cleanPhone.length < 13 ){
                    cleanPhone = prependPart.slice(0, 13 - cleanPhone.length) + cleanPhone;
                }
                return cleanPhone;
            },
            placesListTrigger() {
                this.places_list = !this.places_list;
            },
            paybackSelelectTrigger() {
                if (this.payback_select == true) {
                    this.payback_select = false;
                    this.get_payback = false;
                } else {
                    this.payback_select = true;
                    this.get_payback = true;
                }
            },
            is_allowed_symb (s) {
                return ((/[абвгґдеєжзиіїйклмнопрстуфхцчшщьюяАБВГҐДЕЄЖЗИІЇЙКЛМНОПРСТУФХЦЧШЩЬЮЯ\-\'\s]/.test(s)));
            },
            handleInput (field) {
                let value;
                if(typeof field == 'object') {
                    value = this[field[0]][field[1]];
                    for (let i = 0; i < value.length; i++) {
                        if (!this.is_allowed_symb(value[i])) {
                            this[field[0]][field[1]] = '';
                            return false;
                        }
                    }
                } else {
                    value = this.$data[field];
                    for (let i = 0; i < value.length; i++) {
                        if (!this.is_allowed_symb(value[i])) {
                            this.$data[field] = '';
                            return false;
                        }
                    }
                }
            },
            handleCyrilic(e) {
                if (!this.is_allowed_symb(e.key) && e.key) {
                    e.preventDefault();
                    return false;
                }
            },
            is_allowed_float(n){
                return /^((\d+)|(\d+(\.|\,))|(\d+(\.|\,)\d+))$/.test(n);
            },
            handleFloat(e) {
                e.target.value = e.target.value.replace(',','.');
                if (!this.is_allowed_float(e.target.value + e.key) && e.key) {
                    e.preventDefault();
                }
            },
            handleInt(e) {
                if (!/^(\d+)$/.test(e.target.value + e.key) && e.key) {
                    e.preventDefault();
                    return false;
                }
            },
            handleDesc(e) {
                if (this.description.length > 250) {
                    this.$store.dispatch('setDescError', this.$t('message.desc_limit'));
                    // this.$modal.show('error');
                    this.is_desc_valid = false;
                } else {
                    this.$store.dispatch('setDescError', null);
                    this.is_desc_valid = true;
                }
            },
            scrollTop(e) {
                this.active_tab = e;
                if(window.smoothscroll) window.smoothscroll();
                this.$emit('scrolled')
            },
            getFormatedPhone(phone) {
                if(phone){
                    let formated = this.preparePhone(phone);
                    formated = formated.slice(-9);
                    return [
                        '+38',
                        '0' + formated.slice(0, 2),
                        formated.slice(2, 5),
                        formated.slice(5, 7),
                        formated.slice(7, 9)
                    ].join(' ');
                }
            },
            recalcPlaces() {
                var max_size = 0,
                    max_weight = 0;
                this.must_calculate = true;
                if (this.places.length > 1) {
                    for (let i in this.places) {
                        if (this.places[i].max_size > max_size) {
                            max_size = parseInt(this.places[i].max_size);
                        }
                        max_weight += parseFloat(this.places[i].weight) ? parseFloat(this.places[i].weight) : 0;
                    }
                    this.max_size = max_size || this.max_size;
                    this.weight = max_weight || this.weight;
                }
            },
            prepareCityName(field, value){
                return value.city ? value.city.name_ua + ' ('+ value.region.name_ua+' обл.)' : this.$data[field];
            },
            prepareCity(field,value){
                return value.city ? value.city : this.$data[field];
            },
            removeCargoPlaces(i) {
                this.places.splice(i,1);
                this.package_count--;
            },
            setCity(city, type){
                this.must_calculate = true;
                this[`${type}_city`] = city;
                this[`${type}_departments`] = city.departments;
                this[`${type}_department_no`] = '';
            },
            refreshCity(type){
                this[`${type}_departments`] = this.departments;
                this[`${type}_city`] = {};
            },
            setCityByDepartment(department, type){
                this[`${type}_city`] = this.prepareCity(`${type}_city`, department);
                this[`${type}_city_name`] = this.prepareCityName(`${type}_city_name`, department)
            },
            setDepartment(department, type){
                this[`${type}_department`] = department;
            }
        },
        computed: {
            second_is_avaliable: function () {
                return Boolean(this.to_surname
                    && this.to_name
                    && this.to_middle_name
                    && this.to_city_uuid
                    && this.to_department_no
                    && Object.keys(this.to_department).length
                    && this.is_to_phone_valid
                    && this.from_surname
                    && this.from_name
                    && this.from_middle_name
                    && this.from_city_uuid
                    && this.from_department_no
                    && Object.keys(this.from_department).length
                    && this.is_from_phone_valid
                    && true);
            },
            third_is_avaliable: function () {
                return this.get_payback;
            },
            from_city_uuid: function () {
                return this.from_city.uuid || '';
            },
            to_city_uuid: function () {
                return this.to_city.uuid || '';
            },
            from_full_name: function () {
                return [this.from_surname,
                    (this.from_name || '').substr(0, 1).toUpperCase() + '.',
                    (this.from_middle_name || '').substr(0, 1).toUpperCase() + '.'].join(' ');
            },
            to_full_name: function () {
                return [this.to_surname,
                    (this.to_name || '').substr(0, 1).toUpperCase() + '.',
                    (this.to_middle_name || '').substr(0, 1).toUpperCase() + '.'].join(' ');
            },
            package_created: function () {
                return this.$store.getters.ttn;
            },
            user: function () {
                return this.$store.getters.user;
            },
            from_name: function () {
                return this.$store.getters.user.first_name || '';
            },
            from_surname: function () {
                return this.$store.getters.user.last_name || '';
            },
            from_middle_name: function () {
                return this.$store.getters.user.middle_name || '';
            },
            from_phone: function () {
                return this.$store.getters.user.phone;
            },
            is_from_phone_valid: function () {
                return this.from_phone ? this.from_phone.length > 8 : false;
            },
            is_to_phone_valid: function () {
                return this.to_phone.length > 8;
            },
            is_card_valid: function () {
                if (!this.card_number) {
                    return false;
                }
                let sum = 0;
                for (let i = 0; i < this.card_number.length; i++) {
                    let cardNum = parseInt(this.card_number[i]);
                    if ((this.card_number.length - i) % 2 === 0) {
                        cardNum = cardNum * 2;
                        if (cardNum > 9) {
                            cardNum = cardNum - 9;
                        }
                    }
                    sum += cardNum;
                }
                return sum % 10 === 0;
            },
            cities: function () {
                return this.$store.getters.cities;
            },
            departments: function () {
                return this.$store.getters.departments;
            },
            count_cargo_places: {
                get() {
                    // this.places.pop();
                    return this.package_count;
                },
                set(n_v) {
                    if(n_v == 1) {
                        this.places_list = false;
                    }

                    if (this.package_count > n_v && this.package_count > 1) {
                        this.places.pop();
                        return this.package_count = n_v ? n_v : 1;
                    } else if (this.package_count < n_v && n_v <= 10) {
                        this.places.push({
                            place_name: 'Об`єкт ' + n_v,
                            max_size: '',
                            weight: ''
                        });
                        return this.package_count = (n_v <= 10) ? n_v : 10;
                    }
                }
            },
            count_cargo_places_label: function () {
                let last_number = this.package_count % 10,
                    noun = '';

                if (last_number > 4 || !last_number || (this.package_count > 4 && this.package_count < 21)) {
                    noun = this.$t('message.shipment5N9')
                } else if (last_number > 1 && last_number < 5) {
                    noun = this.$t('message.shipment2N4');
                } else if (last_number == 1) {
                    noun = this.$t('message.shipmentN1');
                }

                return [this.package_count, noun].join(' ');
            },
            transfer_cost: function () {
                return parseInt(this.declared_cost*.02+15);
            },
            weight_error: function () {
                return this.$store.getters.weight_error;
            },
            length_error: function () {
                return this.$store.getters.length_error;
            },
            declared_cost_error: function () {
                return this.$store.getters.declared_cost_error;
            },
            desc_error: function () {
                return this.$store.getters.desc_error;
            },
            from_city_error: function () {
                if(!this.from_city_name){
                    return this.$t('message.required');
                } else {
                    return this.$t('message.city_not_found')
                }
            },
            from_department_error: function () {
                if(!this.from_department_no){
                    return this.$t('message.required');
                } else {
                    return this.$t('message.department_not_found')
                }
            },
            to_city_error: function () {
                if(!this.to_city_name){
                    return this.$t('message.required');
                } else {
                    return this.$t('message.city_not_found')
                }
            },
            to_department_error: function () {
                if(!this.to_department_no){
                    return this.$t('message.required');
                } else {
                    return this.$t('message.department_not_found')
                }
            },
            isDisabledSubmit(){
                return this.must_calculate ||
                    (this.pay_way == 'card' && (!this.is_card_valid || !this.card_number)) ||
                    this.in_progress ||
                    !this.is_max_size_valid ||
                    !this.is_weight_valid ||
                    !this.is_desc_valid ||
                    !this.declared_cost ||
                    !this.description ||
                    !this.is_cost_valid;
            },
            isDisabledCalculateBtn(){
                return !this.must_calculate ||
                    !this.is_cost_valid ||
                    !this.is_desc_valid ||
                    !this.is_max_size_valid ||
                    !this.is_weight_valid;
            }
        },
        watch: {
            user: function () {
                if (this.user.user && this.user.profile) {
                    this.from_surname = this.user.profile.second_name;
                    this.from_name = this.user.user.name;
                    this.from_middle_name = this.user.profile.middle_name;
                }
            },
            max_size: function (n, o) {
                this.must_calculate = (n != o);
                if (n > 90) {
                    this.$store.dispatch('setLengthError', this.$t('message.length_limit'));
                    this.is_max_size_valid = false;
                    // this.$modal.show('error');
                } else if (n == '0') {
                    this.$store.dispatch('setLengthError', this.$t('message.length_not_null'));
                    this.is_max_size_valid = false;
                }else {
                    this.$store.dispatch('setLengthError', null);
                    this.is_max_size_valid = true;
                }
            },
            weight: function (n, o) {
                this.must_calculate = (n != o);
                let tw = n.replace(',','.');
                if (tw > this.to_department.weight_limit) {
                    this.$store.dispatch('setWeightError', this.$t('message.weight_limit_prefix') + this.to_department.weight_limit + this.$t('message.kg'));
                    // this.$modal.show('error');
                    this.is_weight_valid = false;
                } else if (n == '0') {
                    this.$store.dispatch('setWeightError', this.$t('message.weight_not_null'));
                    this.is_weight_valid = false;
                } else {
                    this.$store.dispatch('setWeightError', null);
                    this.is_weight_valid = true;
                }
            },
            departments: function (n,o) {
                this.from_departments = Object.keys(this.from_departments).length ? this.from_departments : n;
                this.to_departments = Object.keys(this.to_departments).length ? this.to_departments : n;
            },
            package_created: function (n,o) {
                if(n) {
                    this.$router.push('/package/success')
                } else {
                    this.in_progress = false;
                }
            },
            declared_cost (n,o) {
                this.must_calculate = (n != o);
                if(n == '0') {
                    this.$store.dispatch('setDeclaredCostError', this.$t('message.cost_not_null'));
                    // this.$modal.show('error');
                    this.is_cost_valid = false;
                } else {
                    this.$store.dispatch('setDeclaredCostError', null);
                    this.is_cost_valid = true;
                }

                this.show_annotation = n > 14999;
            }
        },
        beforeCreate() {
            this.$store.commit('setOrderStatus', {number:null, ttn: null});
            this.$store.dispatch('setCities');
            this.$store.dispatch('setDepartments');
            this.$store.dispatch('set_profile');
        },
        mounted() {
            if (this.$store.state.points) {
                if (this.$store.state.points.to.name_ua) {
                    this.to_city = this.$store.state.points.to;
                    this.to_city_name = this.to_city.name_ua + ' (' + this.to_city.region.name_ua + ' обл.)';
                    this.to_departments = this.to_city.departments;
                }
                if (this.$store.state.points.from.name_ua) {
                    this.from_city = this.$store.state.points.from;
                    this.from_city_name = this.from_city.name_ua + ' (' + this.from_city.region.name_ua + ' обл.)';
                    this.from_departments = this.from_city.departments;
                }
                if(this.$store.state.points.max_length) {
                    this.max_size = this.$store.state.points.max_length;
                }
                if(this.$store.state.points.weight) {
                    this.weight = this.$store.state.points.weight;
                }
            }
            // console.log(this.$store.state.points.to)
            // if(this.$store.state.points.to) this.to_city_name = this.$store.state.points.to
            // if(this.$store.state.points.from) this.from_city_name = this.$store.state.points.from

            window.smoothscroll = () => {
                let currentScroll = document.documentElement.scrollTop || document.body.scrollTop
                if (currentScroll > 0) {
                    window.requestAnimationFrame(window.smoothscroll)
                    window.scrollTo(0, Math.floor(currentScroll - (currentScroll / 5)))
                }
            };
            window.addEventListener('scroll', this.catchScroll)
        },
        destroyed () {
            window.removeEventListener('scroll', this.catchScroll)
        },
    }
</script>



<style>
    @media only screen and (min-width: 1024px) {
        .order.cities_input .drop_list {
            /*margin: 10px 0 0 0;*/
        }
    }
    .form_container .form .block .row input.error {
        border-color: red;
    }
    .label {
        display: none;
    }
    .description_prompt{
        margin-top: 10px;
    }
</style>
